/***************************************************************************/
/*                                                                         */
/*  File: AITank.h                                                         */
/*  Date: 06-02-07                                                         */
/*                                                                         */
/***************************************************************************/
/*
*/
/***************************************************************************/

#ifndef AITANK_H
#define AITANK_H

#include "Tank.h"

class AITank : public Tank
{

public:
	enum AI_TANK_TYPE
	{
		AI_CIRCLE,
		AI_ROAM,
		AI_ATTACK,
	};

	void Update();

	bool Create(Land* land, AI_TANK_TYPE type);



protected:
	AI_TANK_TYPE m_brainType;
	float m_rotStep;
	float m_brainChangeTime;

	VECTOR3 m_target;

	// Make this protected, so if you want to call create, you must also
	// pass in what type of brain you want our tank to have
	bool Create(Land* land)
	{
		m_rotStep = 3.14f;
		
		VECTOR3 min, max;
		land->GetMinMax(min, max);
		m_target = VECTOR3(RandRange(min.x,max.x),
						   0.0f,
						   RandRange(min.z,max.z));

		return Tank::Create(land);
	}

	void UpdateBrainCircle();
	void UpdateBrainRoam();
	void UpdateAttack();

	void SetRandBrainTime() { m_brainChangeTime = RandRange(5.0f, 50.0f); }

};



#endif //AITANK_H
