/***************************************************************************/
/*                                                                         */
/*  File: GLDraw.cpp                                                       */
/*  Date: 06-02-07                                                         */
/*                                                                         */
/***************************************************************************/
/*
	See .h file
*/
/***************************************************************************/

#include "GLDraw.h"

#include <windows.h>    // opengl has issues if we don't include it!
//#include <GL/gl.h>
#include <GL/glu.h>		// gluLookAt(..), glPerspective(..)
//#include <GL/glaux.h>	

#include "Vector3.h"

void DrawUnitCube()
{
	glBegin(GL_QUADS);
    // Front Face
    glNormal3f( 0.0, 0.0, 1.0);
    glVertex3f(-1.0, -1.0,  1.0);
    glVertex3f( 1.0, -1.0,  1.0);
    glVertex3f( 1.0,  1.0,  1.0);
    glVertex3f(-1.0,  1.0,  1.0);
    // Back Face
    glNormal3f( 0.0, 0.0,-1.0);
    glVertex3f(-1.0, -1.0, -1.0);
    glVertex3f(-1.0,  1.0, -1.0);
    glVertex3f( 1.0,  1.0, -1.0);
    glVertex3f( 1.0, -1.0, -1.0);
    // Top Face
    glNormal3f( 0.0, 1.0, 0.0);
    glVertex3f(-1.0,  1.0, -1.0);
    glVertex3f(-1.0,  1.0,  1.0);
    glVertex3f( 1.0,  1.0,  1.0);
    glVertex3f( 1.0,  1.0, -1.0);
    // Bottom Face
    glNormal3f( 0.0,-1.0, 0.0);
    glVertex3f(-1.0, -1.0, -1.0);
    glVertex3f( 1.0, -1.0, -1.0);
    glVertex3f( 1.0, -1.0,  1.0);
    glVertex3f(-1.0, -1.0,  1.0);
    // Right face
    glNormal3f( 1.0, 0.0, 0.0);
    glVertex3f( 1.0, -1.0, -1.0);
    glVertex3f( 1.0,  1.0, -1.0);
    glVertex3f( 1.0,  1.0,  1.0);
    glVertex3f( 1.0, -1.0,  1.0);
    // Left Face
    glNormal3f(-1.0, 0.0, 0.0);
    glVertex3f(-1.0, -1.0, -1.0);
    glVertex3f(-1.0, -1.0,  1.0);
    glVertex3f(-1.0,  1.0,  1.0);
    glVertex3f(-1.0,  1.0, -1.0);
	glEnd();

}// End DrawUnitCube(..)


void DrawCircleXZ(float x, float h, float z, float r )
{
	glLineWidth(1.5);
	glPushMatrix();
	glTranslated(x, h, z);
	glRotatef(0, 1.0f, 0.0f, 0.0f);
	glRotatef(0, 0.0f, 1.0f, 0.0f);
	glRotatef(0, 0.0f, 0.0f, 1.0f);
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_LINE_STRIP);
	{
		static int steps = 10;
		static float inc = (2.0f*3.14f)/steps;
		for (int i=0; i<steps + 1; i++)
		{
			float ang = inc*i;
			float ss = sinf(ang);
			float cc = cosf(ang);

			glColor3f(0x44, 0x44, 0);
			glVertex3f(cc*r, 0, ss*r); 
		}
	}
	glEnd();
	glPopMatrix();

}// End DrawCircleXZ(..)