/***************************************************************************/
/*                                                                         */
/*  File: GLDraw.h                                                         */
/*  Date: 06-02-07                                                         */
/*                                                                         */
/***************************************************************************/
/*
	Because we can't use glut, we need to draw various debug shapes, like
	cubes and spheres and points in our 3d world, so we can confirm that
	our 3d collision and logic is working :)

	So just a library of simple debug draw shapes
*/
/***************************************************************************/

#ifndef GLDRAW_H
#define GLDRAW_H

#include <windows.h>    // opengl has issues if we don't include it!
//#include <GL/gl.h>
#include <GL/glu.h>		// gluLookAt(..), glPerspective(..)
//#include <GL/glaux.h>	

/***************************************************************************/


void DrawUnitCube();

void DrawCircleXZ(float x, float h, float z, float r );


/***************************************************************************/


extern HDC g_hdc;

class DrawString
{
public:
	GLuint fontbase; 

	HFONT   font;                              // Windows Font ID 
    HFONT   oldfont;                           // Used For Good House Keeping 

	DrawString()
	{
		
		fontbase = glGenLists(256);					// Storage For 96 Characters 

		font = CreateFont(-13,						// Height Of Font 
					0,						// Width Of Font 
					0,						// Angle Of Escapement 
					0,						// Orientation Angle 
					FW_BOLD,				// Font Weight 
					FALSE,					// Italic 
					FALSE,					// Underline 
					FALSE,					// Strikeout 
					ANSI_CHARSET,			// Character Set Identifier 
					OUT_TT_PRECIS,			// Output Precision 
					CLIP_DEFAULT_PRECIS,		// Clipping Precision 
					ANTIALIASED_QUALITY,		// Output Quality 
					FF_DONTCARE|DEFAULT_PITCH,	// Family And Pitch 
					"Courier New");				// Font Name 

		oldfont = (HFONT)SelectObject(g_hdc, font);		// Selects The Font We Want 
		wglUseFontBitmaps(g_hdc, 0, 256, fontbase);		// Builds 256 Characters 
		SelectObject(g_hdc, oldfont);					// Selects The Font We Want 
		DeleteObject(font);								// Delete The Font 
	}

	~DrawString()
	{
		glDeleteLists(fontbase, 256);					// Delete All 256 Characters 
	}

	void Print(char* str, float x, float y)
	{
		glMatrixMode(GL_MODELVIEW);		
		glLoadIdentity();

		glMatrixMode(GL_PROJECTION);
		glLoadIdentity();	
		glOrtho(0, 640, 0, 480, -1, 1);

		glScalef(1.0f, 1.0f, 1.0f);
		//glLoadIdentity();					
		glTranslatef(0.0f,450.0f,1.0f);


		glColor3f (1.0f, 1.0f, 1.0f);

		glRasterPos2f (x,   // x pos
					   -y); // y pos, negatated so it goes from top to bottom


		glPushAttrib(GL_LIST_BIT);						// Pushes The Display List Bits 
		glListBase(fontbase);							// Sets The Base Character to 0 
		glCallLists((GLsizei)strlen(str), GL_UNSIGNED_BYTE, str);   // Draws The Display List Text 
		glPopAttrib();									// Pops The Display List Bits 

	}

};



#endif //GLDRAW_H



