/***************************************************************************/
/*                                                                         */
/*  File: Land.h                                                           */
/*  Date: 06-02-07                                                         */
/*                                                                         */
/***************************************************************************/
#ifndef LAND_H
#define LAND_H

#include "Vector3.h"	// VECTOR3


//AUX_RGBImageRec *LoadBMP(char *Filename);

struct stTri
{
	VECTOR3 v[3];
};

class Land
{

	struct stVertex
	{
		FLOAT x, y, z; 
		FLOAT r, g, b;
		FLOAT tu, tv;
	};

	WORD*		m_pIndexBuffer;
	stVertex*	m_pVertexBuffer;
	unsigned int m_texture;

	int m_iNumPolys;
	int m_iNumVertices;

	float m_fStepWidth;
	float m_fStepLength;
	float m_fHeightScale;

	int   m_Columns;
	int   m_Rows;

	VECTOR3 m_vPos;
	VECTOR3 m_min;
	VECTOR3 m_max;

	void RenderLand(float c=1.0f);



	void GetTri(stTri* t, int iA, int iB, int iC) const;
public:
	Land()
	{
		m_pIndexBuffer=NULL;
		m_pVertexBuffer=NULL;
	}
	~Land()
	{
		Release();
	}

	bool Create(char* szHeightMapFile,
				char* szTextureMapFile,
				float fStepWidth,			// Width and Height of each triangle step
				float fStepLength,			// Scale factors!
				float fHeightScale);

	void Release();

	void Render();


	void Move(VECTOR3 v) { Move(v.x, v.y, v.z); };
	void Move(float x, float y, float z);

	float GetHeightApprox(VECTOR3 v) const { return GetHeight(v.x, v.z); }
	float GetHeightApprox(float x, float z) const;

	float GetHeight(VECTOR3 v) const { return GetHeight(v.x, v.z); }
	float GetHeight(float x, float z) const;

	void  GetMinMax(VECTOR3& min, VECTOR3& max) const
	{
		min=m_min;
		max=m_max;

		min += m_vPos;
		max += m_vPos;
	}
};// End Land




#endif //LAND_H

